#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>

HINSTANCE hInst;
HWND hwnd,hStatic;
char szAppName[ ] = "T-Recorder";

int CreateClass();
LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

#define SIZE 176400

HWAVEIN hin;
WAVEFORMATEX wfe = {WAVE_FORMAT_PCM,2,44100,176400,4,16,sizeof(WAVEFORMATEX) };
char buff1[SIZE];
char buff2[SIZE];
char buff3[SIZE];
char buff4[SIZE];
char xbuff[SIZE];

int x;
WAVEHDR wh1 = { buff1, SIZE,0,0,0,1,0,0 } ;
WAVEHDR wh2 = { buff2, SIZE,0,0,0,1,0,0 } ;
WAVEHDR wh3 = { buff3, SIZE,0,0,0,1,0,0 } ;
WAVEHDR wh4 = { buff4, SIZE,0,0,0,1,0,0 } ;
HANDLE hWaveOutput;

DWORD WINAPI th(LPVOID);
DWORD ddd;

typedef struct __riff{
  // riff blok
  char riff[4];
  int rLen; // velikost souboru - 8

  // data blok
  char wave[4];
  struct __format {
    char fID[4];
    unsigned short wFormatTag;
    unsigned short wNeco1;
    unsigned short wNeco2;
    unsigned short nChannels;
    unsigned int nSamplesPerSec;
    unsigned int nAvgBytesPerSec;
    unsigned short nBlockAlign;
    unsigned short nBitsPerSample;
  } format;

  char data[4];
  unsigned int dataLen;
  // nasleduje zvuk

  __riff() {
    strcpy(riff,"RIFF");
    strcpy(wave,"WAVE");
    strcpy(format.fID,"fmt ");
    strcpy(data,"data");
  
    format.wFormatTag = 0x10;
    format.wNeco1 = 0;
    format.wNeco2 = 1;
    format.nChannels = 2; // stereo
    format.nSamplesPerSec = 44100;
    format.nAvgBytesPerSec = 44100*4;
    format.nBlockAlign = 4;
    format.nBitsPerSample = 16;
   
  }
} riff;


int WINAPI WinMain (HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpszArg,int nStyle){
    MSG messages;
    ::hInst = hInst;
   
    if (!CreateClass()) return 0;

    hwnd = CreateWindowEx (WS_EX_TOPMOST|WS_EX_TOOLWINDOW, szAppName, szAppName,
           WS_BORDER|WS_CAPTION|WS_SYSMENU, 200, 200, 120, 50,
           HWND_DESKTOP, NULL, hInst, NULL);
    hStatic = CreateWindow("STATIC","Preparing...",WS_CHILD|WS_VISIBLE,
                 5,5,100,30, hwnd,NULL,hInst,NULL);
    ShowWindow (hwnd, nStyle);

    while (GetMessage (&messages, NULL, 0, 0)){
        TranslateMessage(&messages);
        DispatchMessage(&messages);
    }

    return messages.wParam;
}

int CreateClass() {
    WNDCLASSEX wincl;

    wincl.hInstance = hInst;
    wincl.lpszClassName = szAppName;
    wincl.lpfnWndProc = WindowProcedure;
    wincl.style = CS_DBLCLKS;
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;
    wincl.cbClsExtra = 0;
    wincl.cbWndExtra = 0;
    wincl.hbrBackground = (HBRUSH) CreateSolidBrush( GetSysColor( COLOR_3DFACE ) );

    if (!RegisterClassEx (&wincl)) return 0;
    return 1;
}

FILE *f;

LPVOID cur;
bool copy = false;

LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam){
 switch (message){
  case WM_CREATE: {
    int ret;
    ret = waveInOpen(&hin,WAVE_MAPPER,&wfe,(DWORD)hwnd,0,CALLBACK_WINDOW);
    ret = waveInPrepareHeader(hin,&wh1,sizeof(wh1));
    ret = waveInPrepareHeader(hin,&wh2,sizeof(wh2));
    ret = waveInPrepareHeader(hin,&wh3,sizeof(wh3));
    ret = waveInPrepareHeader(hin,&wh4,sizeof(wh4));
    
    ret = waveInAddBuffer(hin,&wh1,sizeof(wh1));
    ret = waveInAddBuffer(hin,&wh2,sizeof(wh2));
    ret = waveInAddBuffer(hin,&wh3,sizeof(wh3));
    ret = waveInAddBuffer(hin,&wh4,sizeof(wh4));
    ret = waveInStart(hin);
    
    CreateThread(NULL,0,th,NULL,0,&ddd);
  } return 0;

  case WM_CLOSE:
    SetWindowText(hStatic,"Closing...");
    waveInStop(hin);
    waveInReset(hin);
    waveInClose(hin);
    DestroyWindow(hwnd);  
  break;
  
  case WM_DESTROY:
    {
          SetFilePointer(hWaveOutput,0,NULL,FILE_BEGIN);
          riff w;
          w.rLen = GetFileSize(hWaveOutput,NULL) - 8;
          w.dataLen = GetFileSize(hWaveOutput,NULL) - 44;
          DWORD tmp = 0;
          WriteFile(hWaveOutput, &w, sizeof(w), &tmp, NULL);
          CloseHandle(hWaveOutput); 
    }
    PostQuitMessage (0);
  break;
  
  case MM_WIM_OPEN: {
          char aaa[2048];
          SYSTEMTIME st; GetLocalTime(&st);
          sprintf(aaa,"%04d%02d%02d_%02d%02d.wav",
                  st.wYear,st.wMonth,st.wDay,st.wHour,st.wMinute);
  
          hWaveOutput = CreateFile(aaa,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,
                                   FILE_ATTRIBUTE_NORMAL,NULL);
          riff w;
          DWORD tmp = 0;
          WriteFile(hWaveOutput, &w, sizeof(w), &tmp, NULL);
  } break;
//  case MM_WIM_CLOSE: {
//  } break;
  case MM_WIM_DATA : {
          WAVEHDR *whdr = (WAVEHDR*)lParam;
          x = whdr->dwBytesRecorded;
          
          waveInUnprepareHeader(hin,whdr,sizeof(wh1));
          waveInPrepareHeader(hin,whdr,sizeof(wh1));
          waveInAddBuffer(hin,whdr,sizeof(wh1));
          cur = whdr->lpData;
          copy = true;
  } break;
  
  default: return DefWindowProc (hwnd, message, wParam, lParam);
 }
 return 0;
}


DWORD WINAPI th(LPVOID auch){
    DWORD tmp=0;
    int a = 0;
    
    SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_IDLE);
      
    start:
      do { Sleep(1); } while(!copy);
      SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_NORMAL);
      copy = false;
      WriteFile( hWaveOutput, cur, x, &tmp, NULL);
      SetThreadPriority( GetCurrentThread(), THREAD_PRIORITY_IDLE);
      
      char aaa[256] = "Recording";
      for(int i=0;i<a+1;i++) strcat(aaa,".");
      a++; if (a>2) a=0;
      SetWindowText(hStatic,aaa);
      
    goto start;
    return 0;
}

